unit Unit1;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  GL,
  GLUT,
  BaseTypes,
  GLClass,
  ExtCtrls,
  GLText;

type
  TForm1 = class(TForm)
    tmrRender: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure tmrRenderTimer(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
    oGL:TOpenGL;
    temp:TGLFont;

    procedure SetupGLStates;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
     Randomize;

     oGL:=TOpenGL.Create(Self);
     oGL.FullScreen:=false;
     oGL.InitGL;

     SetupGLStates;

     temp:=TGLFont.Create;
     temp.LoadFont(ExtractFilePath(ParamStr(0))+'Data\Font.TGA');
     temp.CharWidth:=512/10;
     temp.CharHeight:=512/10;
     temp.BuildFont(oGL.XRes,oGL.YRes);

     tmrRender.Enabled:=true;
end;

procedure TForm1.tmrRenderTimer(Sender: TObject);
begin
     oGL.ClearColorBuffer;

     Setup2DScreen(oGL.XRes,oGL.YRes);
     glLoadIdentity;

     //I have used absolute co ordinates here to show
     //the scaling/positioning
     temp.Print(10,100,'Hello fonts! :)');

     oGL.Flip;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
     temp.Free;
     oGL.Free;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     case Key of
          VK_ESCAPE:begin
                         tmrRender.Enabled:=false;
                         Close;
          end;
     end;
end;

procedure TForm1.SetupGLStates;
begin
     glDisable(GL_DEPTH_TEST);
     glDisable(GL_LIGHTING);
     glEnable(GL_TEXTURE_2D);
     glEnable(GL_BLEND);
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
     tmrRender.Enabled:=false;
     case Key of
          '1':begin
                   oGL.XRes:=320;
                   oGL.YRes:=240;
          end;
          '2':begin
                   oGL.XRes:=640;
                   oGL.YRes:=480;
          end;
          '3':begin
                   oGL.XRes:=800;
                   oGL.YRes:=600;
          end;
          '4':begin
                   oGL.XRes:=1024;
                   oGL.YRes:=768;
          end;
     end;

     ClientWidth:=oGL.XRes;
     ClientHeight:=oGL.YRes;
     temp.DeleteLists;
     temp.BuildFont(oGL.XRes,oGL.YRes);
     tmrRender.Enabled:=true;
end;

end.
